Exit and Error Codes

Enable Javascript for TOC.

Pipefail

When using pipe, the error code of the first program is ignored. This behavior can be changed by pipefail:
SHELL=/bin/bash -o pipefail

# this lua compilation is only used as syntax check! the lua bytecode files are not used!
%.luao: %.lua | check_luac
	$(LUAC) -o $@ $< 2>&1 | sed 's/^luac[^:]*: //' >&2
or
set -o pipefail
Source: stackoverflow.com

Errno

With the Linux program errno (moreutils) the errno number can be converted into an string (similar like strerror):
$ errno 12
ENOMEM 12 Cannot allocate memory
It also lists all available error numbers:
$ errno -l
EPERM 1 Operation not permitted
ENOENT 2 No such file or directory
ESRCH 3 No such process
EINTR 4 Interrupted system call
EIO 5 Input/output error
ENXIO 6 No such device or address
E2BIG 7 Argument list too long
ENOEXEC 8 Exec format error
[...]

Reserved Exit Codes

There are some recommendations, which exit codes to use.
Edit Code Number Meaning Comment
0 No Error
1 Catchall for general errors Miscellaneous errors, such as "divide by zero" and other impermissible operations
2 Misuse of shell builtins (according Bash documentation) Missing keyword or command, or permission problem (and diff return code on a failed binary file comparison)
126 Command invoked cannot execute Permission problem or command is not an executable
127 "command not found" Possible problem with $PATH or a typo
128 Invalid argument to exit exit takes only integer args in the range 0 - 255
128+n Fatal error signal "n" kill -9 $PPID; $? returns 137 (128 + 9)
130 Script terminated by Control-C Control-C is fatal error signal 2, (130 = 128 + 2, see above)
255 Exit status out of range exit takes only integer args in the range 0 - 255
Source: Advanced Bash-Scripting Guide

Exit Codes according /usr/include/sysexits.h

Define Value Meaning Description
EX_OK 0 successful termination
EX_USAGE 64 command line usage error The command was used incorrectly, e.g., with the wrong number of arguments, a bad flag, a bad syntax in a parameter, or whatever.
EX_DATAERR 65 data format error The input data was incorrect in some way. This should only be used for user's data & not system files.
EX_NOINPUT 66 cannot open input An input file (not a system file) did not exist or was not readable. This could also include errors like "No message" to a mailer (if it cared to catch it).
EX_NOUSER 67 addressee unknown The user specified did not exist. This might be used for mail addresses or remote logins.
EX_NOHOST 68 host name unknown The host specified did not exist. This is used in mail addresses or network requests.
EX_UNAVAILABLE 69 service unavailable A service is unavailable. This can occur if a support program or file does not exist. This can also be used as a catchall message when something you wanted to do doesn't work, but you don't know why.
EX_SOFTWARE 70 internal software error An internal software error has been detected. This should be limited to non-operating system related errors as possible.
EX_OSERR 71 system error (e.g., can't fork) An operating system error has been detected. This is intended to be used for such things as "cannot fork", "cannot create pipe", or the like. It includes things like getuid returning a user that does not exist in the passwd file.
EX_OSFILE 72 critical OS file missing Some system file (e.g., /etc/passwd, /etc/utmp, etc.) does not exist, cannot be opened, or has some sort of error (e.g., syntax error).
EX_CANTCREAT 73 can't create (user) output file A (user specified) output file cannot be created.
EX_IOERR 74 input/output error An error occurred while doing I/O on some file.
EX_TEMPFAIL 75 temp failure; user is invited to retry temporary failure, indicating something that is not really an error. In sendmail, this means that a mailer (e.g.) could not create a connection, and the request should be reattempted later.
EX_PROTOCOL 76 remote error in protocol the remote system returned something that was "not possible" during a protocol exchange.
EX_NOPERM 77 permission denied You did not have sufficient permission to perform the operation. This is not intended for file system problems, which should use NOINPUT or CANTCREAT, but rather for higher level permissions.
EX_CONFIG 78 configuration error
EX__MAX 78 maximum listed value
Source: sysexits.h - 8.1 (Berkeley) 6/2/93